/*	GUI.CPP
	Lots of GUI stuff.
*/

#include "Common.hpp"
#include <DOS.H>
#include <DIRECT.H>
#include <STDARG.H>
#include <IO.H>
#include <fcntl.h>
#include <errno.h>
#include "GrEngine.hpp"
#include "FileMan.hpp"
#include "GUI.hpp"
#include "CPU.hpp"
#include "SPC700.hpp"

	// GUI settings
byte background = 2;
boolean escquits = true;
boolean confirmexit = true;

byte ramcheatmarker [128*1024/8]; // bit=0 when memory is ruled out

boolean msgboxesc;

struct colorset defset = {
	0, 1, 0, 1,
	12, 12, 0, 11,
	1, 3
}, valentineset = {
	7, 1, 6, 5,
	8, 8, 7, 12,
	11, 5
}, christmasset = {
	2, 7, 7, 6,
	12, 10, 5, 7,
	4, 9
}, fallset = {
	6, 6, 0, 7,
	15, 5, 5, 1,
	10, 0
}, coolset = {
	1, 0, 12, 13,
	11, 9, 14, 0,
	6, 3
}, yellowset = {
	5, 0, 14, 15,
	0, 1, 15, 0,
	14, 14
};

struct colorset set = defset;

	// Messages
#define OPENWINDOW 0
	// No arguments
#define CLOSEWINDOW 1
	// No arguments
#define NEWGUIFRAME 2
	// No arguments
#define CONTROLCHANGE 3
	// cnum = Control that was changed; value = sub control
#define KEYPRESS 4
	// cnum = control with focus; value = sub control
#define KEYRELEASE 5
	// cnum = control with focus; value = sub control
#define KEYCHAR 6
	// cnum = control with focus; value = sub control
#define MOUSEPRESS 7
	// value = 1 if it concerns the right button; 0 for left button
#define MOUSERELEASE 8
	// value = 1 if it concerns the right button; 0 for left button

struct guicontrol maincontrols [NUMMAINCONTROLS] = {
	{	BUTTON, { "Return to game","","","","","" }, // 0
		{ 5,0,0,0,0,0 }, { 15,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "Load ROM","","","","","" }, // 1
		{ 5,0,0,0,0,0 }, { 32,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "Startup options","","","","","" }, // 2
		{ 5,0,0,0,0,0 }, { 49,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "In-game options","","","","","" }, // 3
		{ 5,0,0,0,0,0 }, { 66,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "Joypad settings","","","","","" }, // 4
		{ 5,0,0,0,0,0 }, { 83,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "Cheat Codes","","","","","" }, // 5
		{ 5,0,0,0,0,0 }, { 100,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "Save/Load","","","","","" }, // 6
		{ 5,0,0,0,0,0 }, { 117,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "GUI settings","","","","","" }, // 7
		{ 5,0,0,0,0,0 }, { 134,0,0,0,0,0 }, 110, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "Quit","","","","","" }, // 8
		{ 5,0,0,0,0,0 }, { 151,0,0,0,0,0 }, 94, 15,
		1, 0, 0, 0, true
	},
	{	BUTTON, { "X","","","","","" }, // 9
		{ 100,0,0,0,0,0 }, { 151,0,0,0,0,0 }, 15, 15,
		1, 0, 0, 0, true
	},
	{	TEXT, { "Written by Qwertie","\x01 1998        [FPS:xyz]","","","","" },
		{ 5,5,0,0,0,0 }, { 168,176,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	}
};

void mainwindowproc (int msg, int cnum, int v1)
{
	switch (msg) {
	case CONTROLCHANGE:
		switch (cnum) {
		case 0: returntogame = true; break;
		case 1: showwindow (7); break;
		case 2: showwindow (2); break;
		case 3: showwindow (3); break;
		case 4: showwindow (4); break;
		case 5: showwindow (6); break;
		case 6: showwindow (1); break;
		case 7: showwindow (5); break;
		case 8:
			if (romloaded && romrunning && confirmexit)
				messagebox ("ESC Cancels Quit", "Are you sure you want to exit?");
			else
				msgboxesc = false;
			if (!msgboxesc) {
				killwindow (0);
				quitemu = true;
			}
			break;
		case 9:
			if (confirmexit)
				messagebox ("ESC Cancels Quit", "Exit without saving SRAM?");
			else
				msgboxesc = false;
			if (!msgboxesc) {
				loadsram ();
				killwindow (0);
				quitemu = true;
			}
			break;
		}
	case NEWGUIFRAME:
		if (curgsnum == 0) {
			maincontrols[0].disabled = true;
			maincontrols[2].disabled = true;
			maincontrols[3].disabled = true;
			maincontrols[5].disabled = true;
			maincontrols[9].disabled = true;
		} else {
			maincontrols[0].disabled = false;
			maincontrols[2].disabled = false;
			maincontrols[3].disabled = false;
			maincontrols[5].disabled = false;
			maincontrols[9].disabled = false;
		}
		break;
	}
	defwindowproc (mainwindow, msg, cnum, v1);
}

struct guiwindow mainwindow = {
	"SNEqr: Main Menu",
	maincontrols, mainwindowproc,
	NUMMAINCONTROLS,
	false, 10, 44, 120, 190
};

struct guicontrol slc [NUMSAVELOADCONTROLS] = {
	{	BUTTON, { "Save","Load","","","","" }, // Slot 1
		{ 50,80,0,0,0,0 }, { 15,15,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 2
		{ 50,80,0,0,0,0 }, { 27,27,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 3
		{ 50,80,0,0,0,0 }, { 39,39,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 4
		{ 50,80,0,0,0,0 }, { 51,51,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 5
		{ 50,80,0,0,0,0 }, { 63,63,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 6
		{ 50,80,0,0,0,0 }, { 75,75,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 7
		{ 50,80,0,0,0,0 }, { 87,87,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 8
		{ 50,80,0,0,0,0 }, { 99,99,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 9
		{ 50,80,0,0,0,0 }, { 111,111,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Load","","","","" }, // Slot 0
		{ 50,80,0,0,0,0 }, { 123,123,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	TEXT, { "Slot #1","Slot #2","Slot #3","Slot #4","Slot #5","" },
		{ 5,5,5,5,5,0 }, { 18,30,42,54,66,0 }, 0, 0,
		5, 0, 0, 0, false
	},
	{	TEXT, { "Slot #6","Slot #7","Slot #8","Slot #9","Slot #0","" },
		{ 5,5,5,5,5,0 }, { 78,90,102,114,126,0 }, 0, 0,
		5, 0, 0, 0, false
	},
	{	CHECK, { "Auto-backtrack (F10)","","","","","" },
		{ 115,0,0,0,0,0 }, { 15,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	TEXT, { "Time","SRAM save directory","Instant save directory","Screen shot directory","Number","" },
		{ 123,115,115,115,123,0 }, { 25,44,64,84,33,0 }, 30, 11,
		5, 0, 0, 0, false
	},
	{	SLIDER, { " sec.","","","","","" },
		{ 150,0,0,0,0,0 }, { 23,0,0,0,0,0 }, 50, 0,
		0, 4, 120, 1, false
	},
	{	SLIDER, { "x","","","","","" },
		{ 160,0,0,0,0,0 }, { 33,0,0,0,0,0 }, 40, 0,
		1, 1, 9, 1, false
	},
	{	INPUT, { "\0SR2345678901234567890123456789012345678901234567890123456789","","","","","" }, // SRAM save dir
		{ 115,0,0,0,0,0 }, { 52,0,0,0,0,0 }, 125, 11,
		1, 0, 60, 0, false
	},
	{	INPUT, { "\0\0I2345678901234567890123456789012345678901234567890123456789","","","","","" }, // Instant save dir
		{ 115,0,0,0,0,0 }, { 72,0,0,0,0,0 }, 125, 11,
		1, 0, 60, 0, false
	},
	{	INPUT, { "\0SS12345678901234567890123456789012345678901234567890123456789","","","","","" }, // Screen shot dir
		{ 115,0,0,0,0,0 }, { 92,0,0,0,0,0 }, 125, 11,
		1, 0, 60, 0, false
	},
	{	TEXT, { "SRAM","PCX Snapshot","","","","" },
		{ 145,145,0,0,0,0 }, { 117,129,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	CHECK, { "Disallow hotkeys F5/F7","","","","","" },
		{ 115,0,0,0,0,0 }, { 105,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	BUTTON, { "Save","Reload","","","","" }, // SRAM
		{ 180,210,0,0,0,0 }, { 114,114,0,0,0,0 }, 30, 12,
		2, 0, 0, 0, false
	},
	{	BUTTON, { "Save","","","","","" }, // PCX Snapshot
		{ 210,0,0,0,0,0 }, { 126,0,0,0,0,0 }, 30, 12,
		1, 0, 0, 0, false
	}
};

void saveloadwindowproc (int msg, int cnum, int v1)
{
	const static int cautoback = 12, cbacktime = 14, cbacknum = 15, csramdir = 16, cinstdir = 17, csshotdir = 18, cdisallow = 20, csramsaveload = 21, csshotsave = 22;
	int x;
	
	switch (msg) {
	case OPENWINDOW:
		strcpy (slc[csramdir].text[0], sramdir);
		strcpy (slc[cinstdir].text[0], instdir);
		strcpy (slc[csshotdir].text[0],sshotdir);
		break;
	case NEWGUIFRAME:
		strcpy (sramdir, slc[csramdir].text[0]);
		strcpy (instdir, slc[cinstdir].text[0]);
		strcpy (sshotdir,slc[csshotdir].text[0]);
		trimfilespec (sramdir);
		trimfilespec (instdir);
		trimfilespec (sshotdir);
		slc[cautoback].choice = autobacktrack;
		slc[cbacktime].choice = backtracktime;
		slc[cbacknum].choice = backtracknum;
		slc[cdisallow].choice = disallowinst;
		if (curgsnum == 0) {
			for (x = 0; x < 10; x++)
				slc[x].disabled = true;
			slc[csramsaveload].disabled = true;
		} else {
			for (x = 0; x < 10; x++)
				slc[x].disabled = false;
			slc[csramsaveload].disabled = false;
		}
		break;
	case CONTROLCHANGE:
		autobacktrack = slc[cautoback].choice;
		backtracktime = slc[cbacktime].choice;
		if (backtracknum != slc[cbacknum].choice) {
			backtracknum = slc[cbacknum].choice;
			alloc_autobacktrack (backtracknum);
		}
		disallowinst = slc[cdisallow].choice;
		if (cnum < 10) {
			if (v1 == 0 && !romrunning) {
				messagebox ("Instant Save", "Can't save game when it isn't running.");
			} else if (v1 == 0) {
				if (cnum == 9) x = instantsave (0);
				else           x = instantsave (cnum + 1);
				if (x != OKAY)
					messagebox ("Instant Save", "Unable to save game state.");
			} else if (v1 == 1 && !romloaded) {
				messagebox ("Instant Load", "Can't load state when no ROM is loaded.");
			} else if (v1 == 1) {
				if (cnum == 9) x = instantload (0);
				else           x = instantload (cnum + 1);
				if (x != OKAY)
					messagebox ("Instant Load", "Unable to load game state.");
			}
		}
		if (cnum == csramsaveload) {
			if (!romloaded) {
				messagebox ("SRAM Save/Load", "Error: No ROM loaded.");
			} else if (v1 == 0) {
				savesram ();
			} else if (v1 == 1) {
				loadsram ();
			}
		}
		if (cnum == cautoback) {
			if (slc[cautoback].choice == false) {
				dealloc_autobacktrack();
				addmessage ("Memory for auto-backtrack removed");
			} else {
				alloc_autobacktrack(backtracknum);
			}
		}
		break;
	}
	defwindowproc (saveloadwindow, msg, cnum, v1);
}

struct guiwindow saveloadwindow = {
	"Save/Load",
	slc, saveloadwindowproc,
	NUMSAVELOADCONTROLS,
	false, 40, 10, 247, 143
};

struct guicontrol suc [NUMSTARTUPCONTROLS] = {
	{	RADIO, { "Auto","HiROM","LoROM","","","" },
		{ 5,45,85,0,0,0 }, { 15,15,15,0,0,0 }, 0, 0,
		3, 0, 0, 0, false
	},
	{	RADIO, { "Auto","NTSC","PAL","","","" },
		{ 5,45,85,0,0,0 }, { 25,25,25,0,0,0 }, 0, 0,
		3, 0, 0, 0, false
	},
	{	CHECK, { "Interleaved format (ND)","","","","","" },
		{ 13,0,0,0,0,0 }, { 35,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	RADIO, { "Emulate sound processor (ND)","SPC Skip","","","","" },
		{ 5,5,0,0,0,0 }, { 45,73,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	SLIDER, { " KHz","","","","","" },
		{ 13,0,0,0,0,0 }, { 54,0,0,0,0,0 }, 70, 0,
		0, 8, 44, 1, false
	},
	{	CHECK, { "Stereo","","","","","" },
		{ 13,0,0,0,0,0 }, { 63,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	TEXT, { "Method:","","","","","" },
		{ 50,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	SLIDER, { "","","","","","" },
		{ 85,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 30, 0,
		1, 0, 1, 1, false
	},
	{	BUTTON, { "Reset Game","","","","","" },
		{ 50,0,0,0,0,0 }, { 82,0,0,0,0,0 }, 80, 13,
		1, 0, 0, 0, false
	},
	{	CHECK, { "Ignore FastROM flag","","","","","" },
		{ 5,0,0,0,0,0 }, { 98,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	}
};

void startupwindowproc (int msg, int cnum, int v1)
{
	const static int cforcerom = 0, cforcecountry = 1, cinterleaved = 2, csound = 3, ckhz = 4, cstereo = 5, cskipmethod = 7, creset = 8, cignorefastrom = 9;
	
	switch (msg) {
	case OPENWINDOW:
		strcpy (startupwindow.title+9, curgs->filename);
		break;
	case NEWGUIFRAME:
		suc[cforcerom].choice = curgs->forcerom;
		suc[cforcecountry].choice = curgs->forcecountry;
		suc[cinterleaved].choice = false;
		suc[cinterleaved].disabled = true;
		suc[csound].choice = 1;
		suc[csound].disabled = true;
		suc[ckhz].choice = soundkhz;
		suc[cstereo].choice = stereosound;
		suc[cskipmethod].choice = curgs->spcskipmethod;
		suc[cignorefastrom].choice = curgs->ignorefastrom;
		break;
	case CONTROLCHANGE:
		curgs->forcerom = suc[cforcerom].choice;
		curgs->forcecountry = suc[cforcecountry].choice;
		curgs->interleaved = suc[cinterleaved].choice;
		curgs->emulatespc = !suc[csound].choice;
		soundkhz = suc[ckhz].choice;
		stereosound = suc[cstereo].choice;
		curgs->spcskipmethod = suc[cskipmethod].choice;
		curgs->ignorefastrom = suc[cignorefastrom].choice;
		if (cnum == creset) {
			resetsystem (true); // warm boot
		}
		break;
	}
	defwindowproc (startupwindow, msg, cnum, v1);
}

struct guiwindow startupwindow = {
	"Startup: [?]",
	suc, startupwindowproc,
	NUMSTARTUPCONTROLS,
	false, 40, 10, 135, 110
};

struct guicontrol igc [NUMINGAMECONTROLS] = {
	{	RADIO, { "Skip frames","Auto-regulate","","","","" },
		{ 5,80,0,0,0,0 }, { 15,15,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	SLIDER, { " fr.","","","","","" },
		{ 13,0,0,0,0,0 }, { 25,0,0,0,0,0 }, 45, 0,
		0, 0, 9, 1, false
	},
	{	SLIDER, { "%","","","","","" },
		{ 88,0,0,0,0,0 }, { 25,0,0,0,0,0 }, 50, 0,
		0, 10, 200, 5, false
	},
	{	CHECK, { "Graphics speedup (ND)","","","","","" },
		{ 5,0,0,0,0,0 }, { 34,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	CHECK, { "Wait for retrace","Leading edge","","","","" },
		{ 5,90,0,0,0,0 }, { 43,43,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	TEXT, { "Amount of CPU cycles to execute:","Sound Channel Output","Resolution","Color add/subtract (ND)","","" },
		{ 5,5,5,5,0,0 }, { 53,79,103,129,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},
	{	TEXT, { "65c816","SPC (ND)","","","","" },
		{ 5,5,0,0,0,0 }, { 63,71,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	SLIDER, { "%","","","","","" }, // 65c816 cycles
		{ 50,0,0,0,0,0 }, { 63,0,0,0,0,0 }, 75, 0,
		0, 10, 200, 5, false
	},
	{	SLIDER, { "%","","","","","" }, // SPC700 cycles
		{ 50,0,0,0,0,0 }, { 71,0,0,0,0,0 }, 75, 0,
		0, 10, 200, 5, false
	},
	{	CHECK, { "0","1","2","3","","" },
		{ 5,20,35,50,0,0 }, { 87,87,87,87,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},
	{	CHECK, { "4","5","6","7","","" },
		{ 65,80,95,110,0,0 }, { 87,87,87,87,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},
	{	BUTTON, { "Joypads...","","","","","" },
		{ 115,0,0,0,0,0 }, { 98,0,0,0,0,0 }, 45, 15,
		1, 0, 0, 0, false
	},
	{	RADIO, { "256x256","320x200","320x240","360x240","360x360","" },
		{ 5,60,5,60,115,0 }, { 110,110,118,118,118,0 }, 0, 0,
		5, 0, 0, 0, false
	},
	{	RADIO, { "Off","Pattern","Color Table","","","" },
		{ 5,30,75,0,0,0 }, { 136,136,136,0,0,0 }, 0, 0,
		3, 0, 0, 0, false
	},
	{	CHECK, { "BG1","BG2","BG3","BG4","Sprites","" },
		{ 5,30,55,80,105,0 }, { 146,146,146,146,146,0 }, 0, 0,
		5, 0, 0, 0, false
	},
	{	CHECK, { "Windowing","","","","","" },
		{ 5,0,0,0,0,0 }, { 156,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	CHECK, { "Indirect HDMA","","","","","" },
		{ 5,0,0,0,0,0 }, { 164,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
};

void ingamewindowproc (int msg, int cnum, int v1)
{
	const static int cskip_auto = 0, cskipfr = 1, cautorate = 2, cspeedup = 3, cwaittrace = 4, ccpupercent = 7, cspcpercent = 8, csound1to4 = 9, csound5to8 = 10, cjoypads = 11, cgameres = 12, ccoloraddsub = 13, cbgs = 14, cwindowing = 15, cindirecthdma = 16;
	
	switch (msg) {
	case OPENWINDOW:
		strcpy (ingamewindow.title+10, curgs->filename);
		break;
	case NEWGUIFRAME:
		igc[cspeedup].disabled = true;
		igc[cspcpercent].disabled = true;
		igc[ccoloraddsub].disabled = true;
		igc[csound1to4].disabled = true;
		igc[csound5to8].disabled = true;
		
		igc[cskip_auto].choice = curgs->autoreg;
		igc[cskipfr].choice = curgs->frameskip;
		igc[cautorate].choice = curgs->regpercent;
		igc[cspeedup].choice = curgs->grspeedup;
		igc[ccpupercent].choice = curgs->cpupercent;
		igc[cspcpercent].choice = curgs->spcpercent;
		igc[csound1to4].choice = curgs->soundch & 15;
		igc[csound5to8].choice = curgs->soundch >> 4;
		igc[cbgs].choice = curgs->bgs;
		igc[cwaittrace].choice = waitretrace | (leadingedge << 1);
		igc[cgameres].choice = gameres - 1;
		igc[ccoloraddsub].choice = addsubmethod;
		igc[cwindowing].choice = curgs->windowing;
		igc[cindirecthdma].choice = curgs->indirecthdma;
		break;
	case CONTROLCHANGE:
		curgs->autoreg = igc[cskip_auto].choice;
		curgs->frameskip = igc[cskipfr].choice;
		curgs->regpercent = igc[cautorate].choice;
		curgs->grspeedup = igc[cspeedup].choice;
		curgs->cpupercent = igc[ccpupercent].choice;
		curgs->spcpercent = igc[cspcpercent].choice;
		curgs->soundch = igc[csound1to4].choice | (igc[csound5to8].choice << 4);
		curgs->bgs = igc[cbgs].choice;
		curgs->windowing = igc[cwindowing].choice;
		curgs->indirecthdma = igc[cindirecthdma].choice;
		waitretrace = igc[cwaittrace].choice & 1;
		leadingedge = ((igc[cwaittrace].choice & 2) != 0);
		gameres = igc[cgameres].choice + 1;
		addsubmethod = igc[ccoloraddsub].choice;
		if (cnum == cjoypads)
			showwindow (4);
		break;
	}
	defwindowproc (ingamewindow, msg, cnum, v1);
}

struct guiwindow ingamewindow = {
	"Settings: [?]",
	igc, ingamewindowproc,
	NUMINGAMECONTROLS,
	false, 40, 10, 170, 178
};

struct guicontrol jpc [NUMJOYPADCONTROLS] = {
	{	TEXT, { "Input device:","Directions","","","","" },
		{ 5,5,5,5,0,0 }, { 15,51,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	RADIO, { "1","2","","","","" },
		{ 70,85,0,0,0,0 }, { 15,15,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	RADIO, { "Keyboard 1","Keyboard 2","4+ Button Gamepad","Not connected","Extra 1","Extra 2" },
		{ 5,5,5,105,105,105 }, { 25,33,41,25,33,41 }, 0, 0,
		6, 0, 0, 0, false
	},
	{	TEXT, { "L","R","Select","Start","","" },
		{ 98,168,105,143,0,0 }, { 55,55,85,85,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},
	{	TEXT, { "X","Y","A","B","","" },
		{ 238,208,225,238,0,0 }, { 63,75,75,87,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // Up
		{ 35,0,0,0,0,0 }, { 61,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // Down
		{ 35,0,0,0,0,0 }, { 85,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // Left
		{ 5,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // Right
		{ 65,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // L
		{ 105,0,0,0,0,0 }, { 53,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // R
		{ 135,0,0,0,0,0 }, { 53,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // Select
		{ 105,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // Start
		{ 135,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // X
		{ 205,0,0,0,0,0 }, { 61,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // Y
		{ 175,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // A
		{ 235,0,0,0,0,0 }, { 73,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	KEYCODE, { "","","","","","" }, // B
		{ 205,0,0,0,0,0 }, { 85,0,0,0,0,0 }, 30, 11,
		0, 0, 0, 0, false
	},
	{	BUTTON, { "Calibrate joystick...","","","","","" },
		{ 175,0,0,0,0,0 }, { 24,0,0,0,0,0 }, 85, 16,
		1, 0, 0, 0, false
	}
};

void joypadwindowproc (int msg, int cnum, int v1)
{
	const static int cplayer = 1, cinputtype = 2, cup = 5, cdown = 6, cleft = 7, cright = 8, cL = 9, cR = 10, cselect = 11, cstart = 12, cX = 13, cY = 14, cA = 15, cB = 16, ccalibrate = 17;
	struct snesjoypad *curjoy = &joykey [pcontrol[jpc[cplayer].choice]];
	
	switch (msg) {
	case OPENWINDOW:
		jpc[cinputtype].choice = pcontrol[jpc[cplayer].choice];
		break;
	case NEWGUIFRAME:
		jpc[cup].choice = curjoy->up;
		jpc[cdown].choice = curjoy->down;
		jpc[cleft].choice = curjoy->left;
		jpc[cright].choice = curjoy->right;
		jpc[cselect].choice = curjoy->select;
		jpc[cstart].choice = curjoy->start;
		jpc[cL].choice = curjoy->l;
		jpc[cR].choice = curjoy->r;
		jpc[cX].choice = curjoy->x;
		jpc[cY].choice = curjoy->y;
		jpc[cA].choice = curjoy->a;
		jpc[cB].choice = curjoy->b;
		break;
	case CONTROLCHANGE:
		if (cnum == cplayer) {
			jpc[cinputtype].choice = pcontrol[jpc[cplayer].choice];
			break;
		}
		if (cnum == cinputtype) {
			pcontrol[jpc[cplayer].choice] = jpc[cnum].choice;
			break;
		}
		if (cnum == ccalibrate) {
			resetjoysettings ();
			messagebox ("Calibrate Joystick", "Twirl the joystick a few times and press space.");
			addmessage ("X Range: %d-%d; Y Range: %d-%d", joyminx, joymaxx, joyminy, joymaxy);
			messagebox ("Calibrate Joystick", "Center stick and press space.");
			checkjoystick ();
			joymidx = joyposx;			
			joymidy = joyposy;
			addmessage ("Joystick center: %d, %d", joymidx, joymidy);
		}
		curjoy->up = jpc[cup].choice;
		curjoy->down = jpc[cdown].choice;
		curjoy->left = jpc[cleft].choice;
		curjoy->right = jpc[cright].choice;
		curjoy->select = jpc[cselect].choice;
		curjoy->start = jpc[cstart].choice;
		curjoy->l = jpc[cL].choice;
		curjoy->r = jpc[cR].choice;
		curjoy->x = jpc[cX].choice;
		curjoy->y = jpc[cY].choice;
		curjoy->a = jpc[cA].choice;
		curjoy->b = jpc[cB].choice;
		memset (&joykey [3], 0, sizeof (joykey [3]));
		break;
	}
	defwindowproc (joypadwindow, msg, cnum, v1);
}

struct guiwindow joypadwindow = {
	"Joypad input setup",
	jpc, joypadwindowproc,
	NUMJOYPADCONTROLS,
	true, 5, 10, 270, 100
};

struct guicontrol gsc [NUMGUISETTINGCONTROLS] = {
	{	SLIDER, { "","","","","","" }, // Color set: Window
		{ 65,0,0,0,0,0 }, { 23,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Text
		{ 65,0,0,0,0,0 }, { 31,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Control
		{ 65,0,0,0,0,0 }, { 39,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Choice
		{ 65,0,0,0,0,0 }, { 47,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Button
		{ 65,0,0,0,0,0 }, { 55,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Button text
		{ 65,0,0,0,0,0 }, { 63,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Title
		{ 65,0,0,0,0,0 }, { 71,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Title text
		{ 65,0,0,0,0,0 }, { 79,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Focus
		{ 65,0,0,0,0,0 }, { 87,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	SLIDER, { "","","","","","" }, // Color set: Flash
		{ 65,0,0,0,0,0 }, { 95,0,0,0,0,0 }, 85, 0,
		0, 0, 15, 1, false
	},
	{	TEXT, { "Color Sets","Background","Resolution","","","" },
		{ 5,5,5,5,0,0 }, { 15,127,155,0,0,0 }, 0, 0,
		3, 0, 0, 0, false
	},
	{	BUTTON, { "Default","Valentine","Christmas","Autumn","Cool","Yellow" },
		{ 5,57,109,5,57,109 }, { 104,104,104,115,115,115 }, 52, 11,
		6, 0, 0, 0, false
	},
	{	RADIO, { "Black","Rainbow","Game","Dim game","","" },
		{ 60,95,20,60,0,0 }, { 127,127,137,137,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},
	{	TEXT, { "Window","Text","Control","Choice","Button", "Button Text" },
		{ 5,5,5,5,5,5 }, { 25,33,41,49,57,65 }, 0, 0,
		6, 0, 0, 0, false
	},
	{	TEXT, { "Title","Title text","Focus","Flash","","" },
		{ 5,5,5,5,0,0 }, { 73,81,89,97,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},
	{	TEXT, { "At menu, ESC","","","","","" },
		{ 5,0,0,0,0,0 }, { 145,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	RADIO, { "Quits","Returns","","","","" },
		{ 65,105,0,0,0,0 }, { 145,145,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	RADIO, { "256x256","320x200","320x240","360x240","360x360","" },
		{ 5,60,115,5,60,0 }, { 163,163,163,171,171,0 }, 0, 0,
		5, 0, 0, 0, false
	}
};

void guisettingwindowproc (int msg, int cnum, int v1)
{
	const static int cwindowset = 0, ctextset = 1, ccontrolset = 2, cchoiceset = 3, cbuttonset = 4, cbuttontextset = 5, ctitleset = 6, ctitletextset = 7, cfocusset = 8, cflashset = 9, csetselect = 11, cbackground = 12, cwhatesc = 16, cguires = 17;

	switch (msg) {
	case NEWGUIFRAME:
		gsc[cguires].choice = guires-1;
		gsc[cwhatesc].choice = !escquits;
		gsc[cwindowset].choice = set.window;
		gsc[ctextset].choice = set.text;
		gsc[ccontrolset].choice = set.control;
		gsc[cchoiceset].choice = set.choice;
		gsc[cbuttonset].choice = set.button;
		gsc[cbuttontextset].choice = set.buttontext;
		gsc[ctitleset].choice = set.title;
		gsc[ctitletextset].choice = set.titletext;
		gsc[cfocusset].choice = set.focus;
		gsc[cflashset].choice = set.flash;
		gsc[cbackground].choice = background;
		break;
	case CONTROLCHANGE:
		set.window = gsc[cwindowset].choice;
		set.text = gsc[ctextset].choice;
		set.control = gsc[ccontrolset].choice;
		set.choice = gsc[cchoiceset].choice;
		set.button = gsc[cbuttonset].choice;
		set.buttontext = gsc[cbuttontextset].choice;
		set.title = gsc[ctitleset].choice;
		set.titletext = gsc[ctitletextset].choice;
		set.focus = gsc[cfocusset].choice;
		set.flash = gsc[cflashset].choice;
		background = gsc[cbackground].choice;
		escquits = !gsc[cwhatesc].choice;
		guires = gsc[cguires].choice+1;
		if (guires != vidmode) {
			setvideomode (guires, false);
			applycustompalette ();
		}
		if (cnum == csetselect) {
			switch (v1) {
			case 0: set = defset; break;
			case 1: set = valentineset; break;
			case 2: set = christmasset; break;
			case 3: set = fallset; break;
			case 4: set = coolset; break;
			case 5: set = yellowset; break;
			}
		}
		break;
	}
	defwindowproc (guisettingwindow, msg, cnum, v1);
}

struct guiwindow guisettingwindow = {
	"GUI Settings",
	gsc, guisettingwindowproc,
	NUMGUISETTINGCONTROLS,
	false, 40, 10, 165, 182
};

struct guicontrol ccc [NUMCHEATCODECONTROLS] = {
	{	TEXT, { "Code","Description","New Code","Description","Look For:","Set to:" },
		{ 7,100,5,5,5,5 }, { 15,15,73,86,112,125 }, 0, 0,
		6, 0, 0, 0, false
	},	
	{	LISTBOX, { NULL,NULL,NULL,NULL,NULL,NULL },
		{ 5,0,0,0,0,0 }, { 23,0,0,0,0,0 }, 245, 43,
		3, 0, 0, 0, false
	},
	{	INPUT, { "\0\01234567890123456789","","","","","" }, // New code
		{ 55,0,0,0,0,0 }, { 69,0,0,0,0,0 }, 70, 13,
		1, 0, 19, 0, false
	},
	{	INPUT, { "\0\0123456789012345678901234567890123456789","","","","","" }, // Description
		{ 55,0,0,0,0,0 }, { 84,0,0,0,0,0 }, 120, 13,
		1, 0, 40, 0, false
	},
	{	BUTTON, { "Add","","","","","" },
		{ 130,0,0,0,0,0 }, { 69,0,0,0,0,0 }, 30, 13,
		1, 0, 0, 0, false
	},
	{	BUTTON, { "Remove","","","","","" },
		{ 165,0,0,0,0,0 }, { 69,0,0,0,0,0 }, 42, 13,
		1, 0, 0, 0, false
	},
	{	BUTTON, { "Toggle","","","","","" },
		{ 212,0,0,0,0,0 }, { 69,0,0,0,0,0 }, 38, 13,
		1, 0, 0, 0, false
	},
	{	BUTTON, { "Display format","","","","","" },
		{ 180,0,0,0,0,0 }, { 84,0,0,0,0,0 }, 70, 13,
		1, 0, 0, 0, false
	},
	{	TEXT, { "Cheat Searcher","","","","","" },
		{ 5,0,0,0,0,0 }, { 98,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, true
	},
	{	INPUT, { "\0\0123456","","","","","" }, // Look for
		{ 55,0,0,0,0,0 }, { 110,0,0,0,0,0 }, 35, 11,
		1, 0, 6, 0, false
	},
	{	INPUT, { "\0\0123456","","","","","" }, // Set to
		{ 55,0,0,0,0,0 }, { 123,0,0,0,0,0 }, 35, 11,
		1, 0, 6, 0, false
	},
	{	BUTTON, { "Reset & Find All","","","","","" },
		{ 95,0,0,0,0,0 }, { 103,0,0,0,0,0 }, 80, 14,
		1, 0, 0, 0, false
	},
	{	BUTTON, { "Search again","","","","","" },
		{ 95,0,0,0,0,0 }, { 120,0,0,0,0,0 }, 80, 14,
		1, 0, 0, 0, false
	},
	{	RADIO, { "Find Byte","Find Word","","","","" },
		{ 180,180,0,0,0,0 }, { 103,112,0,0,0,0 }, 0, 0,
		2, 0, 0, 0, false
	},
	{	CHECK, { "Find Near","","","","","" },
		{ 180,0,0,0,0,0 }, { 127,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	BUTTON, { "bb.oooo=vvvvh","bb.oooo=vvvvh","bb.oooo=vvvvh","bb.oooo=vvvvh","bb.oooo=vvvvh","bb.oooo=vvvvh" },
		{ 5,88,171,5,88,171 }, { 138,138,138,152,152,152 }, 79, 12,
		6, 0, 0, 0, false
	},
	{	TEXT, { "\x1E 000000 matches (Showing first 0).123456789012345678901234567890123456789","","","","","" },
		{ 5,0,0,0,0,0 }, { 168,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
};

void fillcodelist (struct guicontrol &c, boolean ggformat)
{
	struct listboxinfo *l;
	int y, temp;

	temp = c.choice;
	debug0 ("Initting code list");
	initlistbox (c);
	l = (struct listboxinfo *) c.text[4];
	l->col[1].xoffset = 95;
	l->col[2].xoffset = 85;
	for (y = curgs->patches - 1; y >= 0; y--) {
		addlistentry (c, 0);
		debug0 ("Getting patch name...");
		changelistentry (c, 0, 0, getpatchname (y, ggformat));
		changelistentry (c, 0, 1, curgs->cheat[y]->desc);
		changelistentry (c, 0, 2, curgs->cheat[y]->enabled ? "*" : " ");
	}
	if (temp < l->entries && temp >= 0) // Restore cheat code highlighted before
		c.choice = temp;
	debug0 ("Done init");
}

void updatecheatsearchlisting (int changeto, boolean changetoword = false)
{
	int x, count = 0;
	const static char cfoundb = 15, cnummatches = 16;
	int addr[6];

	for (x = 0; x < 128*1024; x++) {
		if (ramcheatmarker[x >> 3] & (1 << (x & 7))) {
			if (count < 6)
				addr[count] = x;
			count++;
		}
	}
	for (x = 0; x < 6; x++)
		sprintf (ccc[cfoundb].text[x], "");
	if (count == 128*1024 || !romrunning) {
		sprintf (ccc[cnummatches].text[0], "\x1E After you've finished a search, click a code button.", count, count > 6 ? 6 : count);
	} else {
		for (x = 0; x < 6; x++) {
			if (x >= count)
				break;
			if (changetoword) {
				sprintf (ccc[cfoundb].text[x], "%0.6X=%0.4X", 0x7E0000 + addr[x], changeto);
			} else {
				sprintf (ccc[cfoundb].text[x], "%0.6X=%0.2X", 0x7E0000 + addr[x], changeto);
			}
		}
		sprintf (ccc[cnummatches].text[0], "\x1E %d matches (Showing first %d).", count, count > 6 ? 6 : count);	
	}
}

byte debug_ram[1024*128];

void cheatcodewindowproc (int msg, int cnum, int v1)
{
	static boolean ggformat = false;
	const static int clist = 1, cnewcode = 2, cdescr = 3, cadd = 4, cremove = 5, ctoggle = 6, cdformat = 7, clookfor = 9, csetto = 10, cfindall = 11, cfindnext = 12, cfindsize = 13, cfindnear = 14, cfoundb = 15, cnummatches = 16;
	struct listboxinfo *l = (struct listboxinfo *) ccc[clist].text[4];
	int x, lookfor, what;

	debug0 ("Message %d cnum %d v1 %d", msg, cnum, v1);
	switch (msg) {
	case OPENWINDOW:
		fillcodelist (ccc[clist], ggformat);
		strcpy (cheatcodewindow.title+13, curgs->filename);
		break;
	case CLOSEWINDOW:
		debug0 ("UnInitting code list");
		uninitlistbox (ccc[clist]);
		debug0 ("Done unInitting code list");
		break;
	case NEWGUIFRAME:
		if ((guiframes & 8) == 0)
			updatecheatsearchlisting (atoi (ccc[csetto].text[0]), ccc[cfindsize].choice);
		break;
	case CONTROLCHANGE:
		if ((cnum == ctoggle || cnum == cremove || cnum == clist) && l->entries == 0)
			break;
		if (cnum == cdformat) {
			ggformat = !ggformat;
			fillcodelist (ccc[clist], ggformat);
		} else if (cnum == ctoggle && ccc[clist].choice >= 0) {
			togglecheat (ccc[clist].choice);
			changelistentry (ccc[clist], ccc[clist].choice, 2, curgs->cheat[ccc[clist].choice]->enabled ? "*" : " ");
		} else if (cnum == clist) { // Double-click
			sendmessage (&cheatcodewindow, CONTROLCHANGE, ctoggle, 0);
		} else if (cnum == cfindall) {
			memset (ramcheatmarker, 0xFF, sizeof (ramcheatmarker));
			sendmessage (&cheatcodewindow, CONTROLCHANGE, cfindnext, 0);
		} else if (cnum == csetto) {
			updatecheatsearchlisting (atoi (ccc[csetto].text[0]), ccc[cfindsize].choice);			
		} else if (cnum == cfindnext) {
			addmessage ("Searching...");
			showgui ();
			lookfor = atoi (ccc[clookfor].text[0]);
			for (x = 0; x < 1024*128; x++) {
				if (ramcheatmarker[x >> 3] & (1 << (x & 7))) {
					if (ccc[cfindsize].choice) // find word
						what = *(word*)SNESMEM(0x7E0000 + x);
					else
						what = *SNESMEM(0x7E0000 + x);
					if (what != lookfor && (!ccc[cfindnear].choice || what-1 != lookfor) &&\
						                    (!ccc[cfindnear].choice || what+1 != lookfor)) {
						ramcheatmarker[x >> 3] &= ~(1 << (x & 7));
					}
				}
			}
			updatecheatsearchlisting (atoi (ccc[csetto].text[0]), ccc[cfindsize].choice);
		} else if (cnum == cfoundb) {
			strcpy (ccc[cnewcode].text[0], ccc[cfoundb].text[v1]);
		} else if (cnum == cadd) {
			x = createpatch (ccc[cnewcode].text[0], ccc[cdescr].text[0], false);
			if (x < 0) {
				messagebox ("Add Code", "Code is not valid (or out of memory.)");
			} else {
				curgs->cheat[x]->enabled = true;
				fillcodelist (ccc[clist], ggformat);
				ccc[clist].choice = l->entries - 1;
			}
		} else if (cnum == cremove) {
			deletepatch (ccc[clist].choice);
			fillcodelist (ccc[clist], ggformat);
		}
		break;
	case KEYCHAR:
		if (v1 == 194) {
			memset (ramcheatmarker, 0xFF, sizeof (ramcheatmarker));
			memcpy (debug_ram, ram, 1024*128);
			addmessage ("Debug search reset.");
		}
		if (v1 == 195 || v1 == 196) { // F9
			if (v1 == 195) addmessage ("Looking for lower values than before");
			else           addmessage ("Looking for higher values than before");
			for (x = 0; x < 1024*128; x++) {
				if (ramcheatmarker[x >> 3] & (1 << (x & 7))) {
					if (ccc[cfindsize].choice) { // find word
						what =    *(word*)(ram + x);
						lookfor = *(word*)(debug_ram + x);
					} else {
						what    = ram [x];
						lookfor = debug_ram [x];
					}
					if (!(v1 == 195 && what < lookfor) && !(v1 == 196 && what > lookfor)) {
						ramcheatmarker[x >> 3] &= ~(1 << (x & 7));
					}
				}
			}
			memcpy (debug_ram, ram, 1024*128);
		}
		break;
	}
	defwindowproc (cheatcodewindow, msg, cnum, v1);
}

struct guiwindow cheatcodewindow = {
	"Cheat codes: [?]",
	ccc, cheatcodewindowproc,
	NUMCHEATCODECONTROLS,
	true, 40, 10, 255, 180
};

struct guicontrol lc [NUMLOADCONTROLS] = {
	{	LISTBOX, { NULL,NULL,NULL,NULL,NULL,NULL },
		{ 5,0,0,0,0,0 }, { 15,0,0,0,0,0 }, 100, 163,
		2, 0, 0, 0, false
	},
	{	TEXT, { "ROM mapping:","Name:","ROM Size:","File Size:","SRAM Size:","" },
		{ 110,110,110,110,110,0 }, { 35,45,65,75,85,0 }, 0, 0,
		5, 0, 0, 0, false
	},	
	{	TEXT, { "FastROM:","Country #:","License #:","Version #:","Apparent","" },
		{ 110,110,110,110,175,0 }, { 95,105,115,125,27,0 }, 0, 0,
		5, 0, 0, 0, false
	},	
	{	TEXT, { "XxROM","[Name]\0 89012345678901","??? MBits","????? KBytes","??? KBits","" },
		{ 175,110,160,150,160,0 }, { 35,55,65,75,85,0 }, 0, 0,
		5, 0, 0, 0, false
	},	
	{	TEXT, { "Y/N","xxx","xxx","1.xxx","","" },
		{ 160,160,160,160,0,0 }, { 95,105,115,125,0,0 }, 0, 0,
		4, 0, 0, 0, false
	},	
	{	INPUT, { "\0R12345678901234567890123456789012345678901234567890123456789","","","","","" }, // ROM dir
		{ 80,0,0,0,0,0 }, { 182,0,0,0,0,0 }, 130, 11,
		1, 0, 60, 0, false
	},
	{	BUTTON, { "ChDir/Open","","","","","" },
		{ 110,0,0,0,0,0 }, { 15,0,0,0,0,0 }, 60, 15,
		1, 0, 0, 0, false
	},
	{	TEXT, { "ROM Directory","","","","","" },
		{ 5,0,0,0,0,0 }, { 185,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},
	{	RADIO, { "Autodetect type","Force HiROM","Force LoROM","","","" },
		{ 110,110,110,0,0,0 }, { 135,144,153,0,0,0 }, 0, 0,
		3, 0, 0, 0, false
	}
};

void fillfilelist (struct guicontrol &c, char *path)
{
	struct listboxinfo *l = (struct listboxinfo *) c.text[4];
	unsigned y, p, temp;
	unsigned original;
	char temps [80];
	DIR *dirp;
    struct dirent *direntp;
	char *ext;

	l->col[1].xoffset = 55;
	_dos_getdrive (&original);
	for (y = 26; y > 0; y--) {
		_dos_setdrive (y, &temp);
		_dos_getdrive (&temp);
		if (temp == y) {
			addlistentry (c, 0);
			temps [0] = 'A'+y-1;
			temps [1] = ':';
			temps [2] = '\0';
			changelistentry (c, 0, 0, temps);
			changelistentry (c, 0, 1, "<Drive>");
		}
	}
	_dos_setdrive (original, &temp);
	dirp = opendir (path);
	if (dirp != NULL) {
		p = 0;
	    while (1) {
			direntp = readdir (dirp);
			if (direntp == NULL) break;
			strcpy (temps, direntp->d_name);
			strupr (temps);
			ext = temps + findfirstch (temps, '.') + 1;
			if ((direntp->d_attr & _A_SUBDIR) != 0 ||
				(ext[0] == 'S' && ext [2] == 'C' && (ext [1] == 'M' || ext [1] == 'F' || ext [1] == 'W' )) ||
				(ext[0] == 'F' && ext [1] == 'I' && ext [2] == 'G') || (ext[0] == '1' && ext [1] == '\0')) {
				addlistentry (c, p);
				changelistentry (c, p, 0, temps);
				if ((direntp->d_attr & _A_SUBDIR) != 0)
					changelistentry (c, p, 1, "<Dir>");
				p++;
			}
		}
		closedir (dirp);
	}
}

void loadwindowproc (int msg, int cnum, int v1)
{
	const static int cfiles = 0, cromdir = 5, copen = 6, cforcerom = 8;
	struct listboxinfo *l = (struct listboxinfo *) lc[cfiles].text[4];
	char newpath [80], *fn;
	long x;
	static char curfn [20];
	static struct headerdata curh;
	FILE *fp;
	
	switch (msg) {
	case OPENWINDOW:
		initlistbox (lc[cfiles]);
		strcpy (lc[cromdir].text[0], romdir);
		fillfilelist (lc[cfiles], lc[cromdir].text[0]);
		if (loadwindow.y + loadwindow.h > yres) {
			loadwindow.y = yres - loadwindow.h;
		}
		break;
	case CLOSEWINDOW:
		uninitlistbox (lc[cfiles]);
		break;
	case KEYCHAR:
		if (cnum == cromdir && v1 == 13) {
			strcpy (romdir, lc[cromdir].text[0]);		
			initlistbox (lc[cfiles]);
			fillfilelist (lc[cfiles], lc[cromdir].text[0]);
		}
		break;
	case NEWGUIFRAME:
		if ((guiframes & 3) == 0) { // Update ROM info display
			if (lc[cfiles].text[1][findlistentry (lc[cfiles], lc[cfiles].choice, 1)] != '<') {
				lc[1].hidden = false; lc[2].hidden = false;
				lc[3].hidden = false; lc[4].hidden = false;
				fn = lc[cfiles].text[0] + findlistentry (lc[cfiles], lc[cfiles].choice, 0);
				if (stricmp (fn, curfn) != 0) {
					x = findgsnum (fn);
					lc[cforcerom].choice = gs[x]->forcerom;
					combinepathfile (newpath, romdir, fn);
					loadromheaderdata (newpath, &curh,
						lc[cforcerom].choice == 1 ? FORCEHIROM : (lc[cforcerom].choice == 2 ? FORCELOROM : 0));
					fp = fopen (newpath, "rb");
					fseek (fp, 0, SEEK_END);
					x = ftell (fp);
					fclose (fp);
					sprintf (lc[3].text[3], "%d KBytes", x / 1024);
					strcpy (curfn, fn);
					strcpy (lc[3].text[1], curh.name);
					if (curh.hirom) {
						lc[3].text[0][0] = 'H'; lc[3].text[0][1] = 'i';
					} else {
						lc[3].text[0][0] = 'L'; lc[3].text[0][1] = 'o';
					}
					sprintf (lc[3].text[2], "%d MBits", curh.romsize);
					sprintf (lc[3].text[4], "%d KBits", curh.sramsize);
					if (curh.fastrom) {
						lc[4].text[0][0] = 'Y'; lc[4].text[0][1] = 'e'; lc[4].text[0][2] = 's';
					} else {
						lc[4].text[0][0] = 'N'; lc[4].text[0][1] = 'o'; lc[4].text[0][2] = '\0';
					}
					sprintf (lc[4].text[1], "%d", curh.country);
					sprintf (lc[4].text[2], "%d", curh.license);
					sprintf (lc[4].text[3], "1.%d", curh.version);
				}
			} else {
				lc[1].hidden = true; lc[2].hidden = true;
				lc[3].hidden = true; lc[4].hidden = true;
			}
		}
		break;
	case CONTROLCHANGE:
		if (cnum == cfiles) {
			x = findlistentry (lc[cfiles], v1, 1);
			if (lc[cfiles].text[1][x] == '<') { // Change directory
				combinepaths (newpath, romdir, lc[cfiles].text[0] + findlistentry (lc[cfiles], v1, 0));
				strcpy (romdir, newpath);
				strcpy (lc[cromdir].text[0], newpath);
				initlistbox (lc[cfiles]);
				fillfilelist (lc[cfiles], newpath);
			} else { // Load ROM
				debug0 ("Before combinepathfile");
				combinepathfile (newpath, romdir, lc[cfiles].text[0] + findlistentry (lc[cfiles], v1, 0));
				debug0 ("Before loadrom");
				debug0 ("Newpath:%s", newpath);
				loadrom (newpath, true,
					lc[cforcerom].choice == 1 ? FORCEHIROM : (lc[cforcerom].choice == 2 ? FORCELOROM : 0));
				memset (ramcheatmarker, 0xFF, sizeof (ramcheatmarker));
				updatecheatsearchlisting (0);
					// Reset the cheat searcher marked memory list.
			}
		}
		if (cnum == copen)
			sendmessage (&loadwindow, CONTROLCHANGE, cfiles, lc[cfiles].choice);
		if (cnum == cforcerom) {
			x = findgsnum (curfn);
			gs[x]->forcerom = lc[cforcerom].choice; // enforce choice made
			curfn [0] = '\0'; // will cause reload of rom header data
		}
		break;
	}
	defwindowproc (loadwindow, msg, cnum, v1);
}

struct guiwindow loadwindow = {
	"Load File: *.SMC;*.SFC;*.SWC;*.FIG;*.1",
	lc, loadwindowproc,
	NUMLOADCONTROLS,
	true, 40, 10, 220, 200
};

struct guicontrol mbc [NUMMESSAGEBOXCONTROLS] = {
	{	TEXT, { "\0\0123456789012345678901234567890123456789012345678901234567890","","","","","" },
		{ 5,0,0,0,0,0 }, { 17,0,0,0,0,0 }, 0, 0,
		1, 0, 0, 0, false
	},	
	{	BUTTON, { "OK","","","","","" },
		{ 5,0,0,0,0,0 }, { 27,0,0,0,0,0 }, 35, 15,
		1, 0, 0, 0, false, false, true
	},
	{	SLIDER, { "MBit read","","","","","" },
		{ 45,0,0,0,0,0 }, { 33,0,0,0,0,0 }, 75, 0,
		0, 0, 1, 1, false
	},
};

void messagebox (char *title, char *msg)
{
	boolean bdown = false, prevexec = false, prevlb = false, curexec;
	int x;
	
	mbc [2].hidden = true;
	mbc [1].hidden = false;
	strcpy (mbc[0].text[0], msg);
	strcpy (messagewindow.title, title);
	showwindow (&messagewindow);
	msgboxesc = false;
	do {
		prevexec = keydown [KEYSPACE] | keydown [KEYENTER];
		prevlb = lbutton;
		checkjoystick (); // In case the purpose of the message box is to calibrate the joystick.
		setguisettings ();
		showgui ();
		curexec = keydown [KEYSPACE] | keydown [KEYENTER];
		if (curexec && !prevexec)
			sendmessage (&messagewindow, KEYPRESS, 1, KEYENTER);
		if (!curexec && prevexec)
			sendmessage (&messagewindow, KEYRELEASE, 1, KEYENTER);
		if (lbutton && !prevlb)
			sendmessage (&messagewindow, MOUSEPRESS, -1, 0);
		if (!lbutton && prevlb)
			sendmessage (&messagewindow, MOUSERELEASE, -1, 0);
		if (kbhit ()) {
			x = getch ();
			if (x == 0)
				x = getch () + 128;
			sendmessage (&messagewindow, KEYCHAR, 1, x);
		}
	} while (messagewindow.zorder == 0);
}

void messagewindowproc (int msg, int cnum, int v1)
{
	messagewindow.focus = 1; // OK button, which is invisible when loading files
	switch (msg) {
	case CONTROLCHANGE:
		if (cnum == 1) {
			killwindow (&messagewindow);
			return;
		}
		break;
	case KEYCHAR:
		if (v1 == 27) {
			msgboxesc = true;
			killwindow (&messagewindow);
			return;
		}
		break;
	}
	defwindowproc (messagewindow, msg, cnum, v1);
}

struct guiwindow messagewindow = {
	"[?]",
	mbc, messagewindowproc,
	NUMMESSAGEBOXCONTROLS,
	false, 95, 150, 180, 48
};

struct guiwindow *win [NUMWINDOWS] = {
	&mainwindow,
	&saveloadwindow,
	&startupwindow,
	&ingamewindow,
	&joypadwindow,
	&guisettingwindow,
	&cheatcodewindow,
	&loadwindow,
	&messagewindow
};

/*
. 
. 
. ۲
.  ۲۲۲  ۲  
. ۰۰   ۲۱ ۲۲  ۲۲  
.   ۲۲     ۲   ۲۲ ۲۲ 
.   ۲۲   ۲۱ ۲۲  ۲۲  
. ۲۲ ۲۲۲  ۲  
. ۲
. 
. ^ Good size ^
. 
*/

void drawwindow (struct guiwindow &w, boolean active)
{
	int x, x2, y;

	drawpatternbox (w.x, w.y, w.x+w.w-1, w.y+w.h-1, CCOLOR(set.window,active ? 11 : 10) + (set.window==0?1:set.window<5?-1:0), w.skip);
	if (w.skip == 0) {
		hline (w.y      , w.x, w.x+w.w-1, CCOLOR(set.window, 14));
		hline (w.y+w.h-1, w.x, w.x+w.w-1, CCOLOR(set.window, 2));
		vline (w.x      , w.y, w.y+w.h-1, CCOLOR(set.window, 14));
		vline (w.x+w.w-1, w.y, w.y+w.h-1, CCOLOR(set.window, 2));
	}
	for (y = 0; y < 8; y++) {
		x = (w.x+2) + (w.w-5) * y / 8;
		x2 = w.x+1 + (w.w-4) * (y+1) / 8;
		drawbox (x, w.y+2, x2, w.y+12, CCOLOR (set.title, ((active?15:7) - y)));
		if (y != 0)
			drawpatternbox (x - w.w/16, w.y+2, x, w.y+12, CCOLOR (set.title, ((active?15:7) - y)));
	}
	setcolor (CCOLOR (set.titletext, active ? 0 : 14));
	outtext10 (w.x+3, w.y+3, w.title);
		// Drawing the 'X'
	drawbox (w.x+w.w-12, w.y+3, w.x+w.w-4, w.y+11, CCOLOR (set.button, 10));
	hline (w.y+3,  w.x+w.w-12, w.x+w.w-4, CCOLOR(set.button, (w.xclicked ? 2 : 13)));
	hline (w.y+11, w.x+w.w-12, w.x+w.w-4, CCOLOR(set.button, (w.xclicked ? 13 : 2)));
	vline (w.x+w.w-12, w.y+3, w.y+11, CCOLOR(set.button, (w.xclicked ? 2 : 13)));
	vline (w.x+w.w-4,  w.y+3, w.y+11, CCOLOR(set.button, (w.xclicked ? 13 : 2)));
	point (w.x+w.w-10, w.y+5, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-9,  w.y+6, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-8,  w.y+7, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-7,  w.y+8, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-6,  w.y+9, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-6,  w.y+5, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-7,  w.y+6, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-9,  w.y+8, CCOLOR(set.buttontext, 1));
	point (w.x+w.w-10, w.y+9, CCOLOR(set.buttontext, 1));
	for (y = 0; y < w.numcontrols; y++) {
		if (!w.c[y].hidden)
			drawcontrol (w.c[y], w.x, w.y, (w.focus == y) & active, w.skip);
	}
}

void drawcontrol (struct guicontrol &c, int wx, int wy, boolean focus, int skip)
{
	int shadow, highlight, controltext = CCOLOR(set.control,c.disabled?5:0);
	int x, y, cx = wx + c.x[0], cy = wy + c.y[0], p, cp;
	char temps [10], *t;
	struct listboxinfo *l;

	switch (c.type) {
	case TEXT:
		for (y = 0; y < c.number; y++) {
			cx = wx + c.x[y];
			cy = wy + c.y[y];
			setcolor (CCOLOR(set.text,1));
			if (c.largefont) outtext10 (cx, cy, c.text[y], focus && c.focus == y);
			else outtext8 (cx, cy, c.text[y], focus && c.focus == y);
		}
		break;
	case RADIO: case CHECK:
		for (y = 0; y < c.number; y++) {
			shadow =     (c.clicked && y == c.focus ? CCOLOR(set.flash,12) : CCOLOR(set.window,2));
			highlight =  (c.clicked && y == c.focus ? CCOLOR(set.flash,12) : CCOLOR(set.window,13));
			if (!c.disabled)
				controltext = (c.clicked && y == c.focus ? CCOLOR(set.flash,3) : CCOLOR(set.control,1));
			cx = wx + c.x[y];
			cy = wy + c.y[y];
			if (c.largefont) cy++;
			drawbox (cx+1, cy+1, cx+5, cy+5, CCOLOR (set.control, 15));
			if (c.type == RADIO) {
				hline (cy, cx+2, cx+4, shadow);
				vline (cx, cy+2, cy+4, shadow);
				hline (cy+6, cx+2, cx+4, highlight);
				vline (cx+6, cy+2, cy+4, highlight);
				point (cx+1, cy+1, shadow); point (cx+5, cy+1, shadow);
				point (cx+1, cy+5, shadow); point (cx+5, cy+5, highlight);
				if (c.choice == y) {
					hline (cy+3, cx+2, cx+4, CCOLOR (set.choice, 1));
					vline (cx+3, cy+2, cy+4, CCOLOR (set.choice, 1));
					point (cx+2, cy+2, CCOLOR (set.choice, 6));
					point (cx+4, cy+2, CCOLOR (set.choice, 6));
					point (cx+2, cy+4, CCOLOR (set.choice, 6));
					point (cx+4, cy+4, CCOLOR (set.choice, 6));
				}
			} else {
				hline (cy, cx, cx+6, shadow);
				hline (cy+6, cx, cx+6, highlight);
				vline (cx, cy, cy+6, shadow);
				vline (cx+6, cy, cy+6, highlight);
				if ((c.choice >> y) & 1) {
					point (cx+1, cy+1, CCOLOR (set.choice, 2));
					point (cx+2, cy+2, CCOLOR (set.choice, 2));
					point (cx+3, cy+3, CCOLOR (set.choice, 2));
					point (cx+4, cy+4, CCOLOR (set.choice, 2));
					point (cx+5, cy+5, CCOLOR (set.choice, 2));
					point (cx+5, cy+1, CCOLOR (set.choice, 2));
					point (cx+4, cy+2, CCOLOR (set.choice, 2));
					point (cx+2, cy+4, CCOLOR (set.choice, 2));
					point (cx+1, cy+5, CCOLOR (set.choice, 2));
				}
			}
			setcolor (controltext);
			if (c.largefont) outtext10 (cx+8, cy-1, c.text[y], focus && c.focus == y);
			else outtext8 (cx+8, cy, c.text[y], focus && c.focus == y);
		}
		break;
	case BUTTON:
		for (y = 0; y < c.number; y++) {
			cx = wx + c.x[y];
			cy = wy + c.y[y];
			//drawbox (cx, cy, cx+c.w-1, cx+c.h-1, CCOLOR (set.button, 10));
			drawpatternbox (cx, cy, cx+c.w-1, cy+c.h-1, CCOLOR(set.button, 10), skip);
			p = c.clicked && (c.focus == y);
			hline (cy,       cx, cx+c.w-1, CCOLOR(set.button, p ? 2 : 13));
			hline (cy+c.h-1, cx, cx+c.w-1, CCOLOR(set.button, p ? 13 : 2));
			vline (cx,       cy, cy+c.h-1, CCOLOR(set.button, p ? 2 : 13));
			vline (cx+c.w-1, cy, cy+c.h-1, CCOLOR(set.button, p ? 13 : 2));
			if (p) {
				hline (cy+1, cx+1, cx+c.w-2, CCOLOR(set.button, 6));
				vline (cx+1, cy+1, cy+c.h-2, CCOLOR(set.button, 6));
				cx++;
				cy++;
			}
			setcolor (CCOLOR (set.buttontext, c.disabled ? 5 : 1));
			if (c.largefont) {
				cx += (c.w - textwidth10(c.text[y])) / 2;
				cy += (c.h - 8) / 2;
				outtext10 (cx, cy, c.text[y], focus && c.focus == y);
			} else {
				cx += (c.w - textwidth8 (c.text[y])) / 2;
				cy += (c.h - 6) / 2;
				outtext8 (cx, cy, c.text[y], focus && c.focus == y);
			}
		}
		break;
	case SLIDER:
		if (c.largefont)
			cy++;
		if (focus)
			drawdottedlinebox (cx - 1, cy, cx + c.w, cy + 7, CCOLOR (set.focus, 5));
		hline (cy+2, cx, cx+c.w-1, CCOLOR(set.window, 2));
		hline (cy+4, cx, cx+c.w-1, CCOLOR(set.window, 14));
		vline (cx,       cy+2, cy+4, CCOLOR(set.window, 2));
		vline (cx+c.w-1, cy+2, cy+4, CCOLOR(set.window, 14));
		// p-min       ?
		//------- = -------
		//max-min     c.w
		p = INLIMITS (c.choice, c.min, c.max);
		p = (p-c.min) * (c.w-4) / (c.max-c.min) + cx;
		drawbox (p+1, cy, p+2, cy+6, CCOLOR(set.choice, 10));
		hline (cy,   p, p+3, CCOLOR(set.choice, 13));
		hline (cy+6, p, p+3, CCOLOR(set.choice, 1));
		vline (p,   cy, cy+6, CCOLOR(set.choice, 13));
		vline (p+3, cy, cy+6, CCOLOR(set.choice, 1));		
		setcolor (controltext);
		sprintf (temps, "%d", c.choice);
		if (c.largefont) {
			outtext10 (cx+c.w+2, cy-1, temps);
			p = textwidth10 (temps);
			outtext10 (cx+c.w+p+6, cy-1, c.text[0]);
		} else {
			outtext8 (cx+c.w+2, cy, temps);
			p = textwidth8 (temps);
			outtext8 (cx+c.w+p+5, cy, c.text[0]);
		}
		break;
	case KEYCODE:
		drawbox (cx, cy, cx+c.w-1, cy+c.h-1, CCOLOR (set.control, 15));
		hline (cy,       cx, cx+c.w-1, CCOLOR (set.window, 2));
		hline (cy+c.h-1, cx, cx+c.w-1, CCOLOR (set.window, 13));
		vline (cx,       cy, cy+c.h-1, CCOLOR (set.window, 2));
		vline (cx+c.w-1, cy, cy+c.h-1, CCOLOR (set.window, 13));
		if (c.largefont) {
			cx += (c.w - textwidth10(keyname [c.choice])) / 2;
			cy += (c.h - 8) / 2;
			outtext10 (cx, cy, keyname [c.choice], focus);
		} else {
			cx += (c.w - textwidth8 (keyname [c.choice])) / 2;
			cy += (c.h - 6) / 2;
			outtext8 (cx, cy, keyname [c.choice], focus);
		}		
		break;
	case INPUT:
		//cx = wx + c.x[0];
		//cy = wy + c.y[0];
		//drawbox (cx, cy, cx+c.w-1, cx+c.h-1, CCOLOR (set.button, 10));
		drawbox (cx, cy, cx+c.w-1, cy+c.h-1, CCOLOR (set.control, 15));
		hline (cy,       cx, cx+c.w-1, CCOLOR (set.window, 2));
		hline (cy+c.h-1, cx, cx+c.w-1, CCOLOR (set.window, 13));
		vline (cx,       cy, cy+c.h-1, CCOLOR (set.window, 2));
		vline (cx+c.w-1, cy, cy+c.h-1, CCOLOR (set.window, 13));
		cp = cx + 2;
		for (y = 0, p = 0; (p = textwidth (c.text[0]+y, c.largefont)) > c.w-4; y++) {
			//cp -= c.largefont ? width10[c.text[0][y]] : width8[c.text[0][y]];
		}
		for (x = y; x < c.choice; x++) {
			cp += c.largefont ? width10[c.text[0][x]] : width8[c.text[0][x]];
		}
		outtext (cx+2, cy+2, c.text[0] + y, c.largefont);
		if ((tmsec & 512) == 0 && focus && y <= c.choice) {
			vline (cp-1, cy + 2, cy + c.h - 3, CCOLOR (set.focus, 2));
		}
		break;
	case LISTBOX:
		drawpatternbox (cx, cy, cx+c.w-1, cy+c.h-1, CCOLOR (set.control, 15), skip);
		hline (cy,       cx, cx+c.w-1, CCOLOR (set.window, 2));
		hline (cy+c.h-1, cx, cx+c.w-1, CCOLOR (set.window, 13));
		vline (cx,       cy, cy+c.h-1, CCOLOR (set.window, 2));
		vline (cx+c.w-1, cy, cy+c.h-1, CCOLOR (set.window, 13));
		if (c.text[4] == NULL)
			break; // Not initted
		l = (struct listboxinfo *) c.text[4];
		if (c.choice >= l->offset && c.choice < l->offset + l->lines) {
			drawbox (cx+1, cy+1 + (c.choice-l->offset) * (c.largefont ? 10 : 8),
				cx+c.w-2, cy+1 + (c.choice+1-l->offset) * (c.largefont ? 10 : 8), CCOLOR (set.choice, 10));
			if (focus)
				drawdottedlinebox (cx+1, cy+1 + (c.choice-l->offset) * (c.largefont ? 10 : 8),
					cx+c.w-2, cy+1 + (c.choice+1-l->offset) * (c.largefont ? 10 : 8), CCOLOR (set.focus, 5));
		}
		if (l->shaft) {
			// First the up arrow box...
			drawbox (cx+c.w-12, cy+1, cx+c.w-2, cy+11, CCOLOR (set.control, 8));
			hline (cy+1,  cx+c.w-12, cx+c.w-2, CCOLOR (set.control, l->upclicked ? 2 : 13));
			hline (cy+11, cx+c.w-12, cx+c.w-2, CCOLOR (set.control, l->upclicked ? 13 : 2));
			vline (cx+c.w-12, cy+1, cy+11, CCOLOR (set.control, l->upclicked ? 2 : 13));
			vline (cx+c.w-2,  cy+1, cy+11, CCOLOR (set.control, l->upclicked ? 13 : 2));
			hline (cy+7, cx+c.w-10,cx+c.w-4, CCOLOR (set.control, 1));
			hline (cy+6, cx+c.w-9, cx+c.w-5, CCOLOR (set.control, 1));
			hline (cy+5, cx+c.w-8, cx+c.w-6, CCOLOR (set.control, 1));
			hline (cy+4, cx+c.w-7, cx+c.w-7, CCOLOR (set.control, 1));
			// Now the down arrow box...
			drawbox (cx+c.w-12, cy+c.h-12, cx+c.w-2, cy+c.h-2, CCOLOR (set.control, 8));			
			hline (cy+c.h-12, cx+c.w-12, cx+c.w-2, CCOLOR (set.control, l->downclicked ? 2 : 13));
			hline (cy+c.h-2,  cx+c.w-12, cx+c.w-2, CCOLOR (set.control, l->downclicked ? 13 : 2));
			vline (cx+c.w-12, cy+c.h-12, cy+c.h-2, CCOLOR (set.control, l->downclicked ? 2 : 13));
			vline (cx+c.w-2,  cy+c.h-12, cy+c.h-2, CCOLOR (set.control, l->downclicked ? 13 : 2));
			hline (cy+c.h-8, cx+c.w-10,cx+c.w-4, CCOLOR (set.control, 1));
			hline (cy+c.h-7, cx+c.w-9, cx+c.w-5, CCOLOR (set.control, 1));
			hline (cy+c.h-6, cx+c.w-8, cx+c.w-6, CCOLOR (set.control, 1));
			hline (cy+c.h-5, cx+c.w-7, cx+c.w-7, CCOLOR (set.control, 1));
			// And the shaft in the middle...
			drawbox        (cx+c.w-12, cy+12, cx+c.w-2, cy+c.h-13, CCOLOR (set.control, 12));
			drawpatternbox (cx+c.w-12, cy+12, cx+c.w-2, cy+c.h-13, CCOLOR (set.control, 9), 1);
			drawbox (cx+c.w-12, cy+12+l->sboxpos, cx+c.w-2, cy+11+l->sboxpos+l->sboxht, CCOLOR (set.control, 8));
			hline (cy+12+l->sboxpos,           cx+c.w-12, cx+c.w-2, CCOLOR (set.control, 13));
			hline (cy+11+l->sboxpos+l->sboxht, cx+c.w-12, cx+c.w-2, CCOLOR (set.control, 2));
			vline (cx+c.w-12, cy+12+l->sboxpos, cy+11+l->sboxpos+l->sboxht, CCOLOR (set.control, 13));
			vline (cx+c.w-2,  cy+12+l->sboxpos, cy+11+l->sboxpos+l->sboxht, CCOLOR (set.control, 2));
		}
		for (x = 0; x < 4; x++) {
			t = c.text[x] + findlistentry (c, l->offset, x);
			p = cy + 2;
			for (y = 0; y < l->lines; y++) {
				if (l->offset + y < l->entries) {
					setcolor (CCOLOR (set.control, 1));
					outtext (cx + l->col[x].xoffset, p, t, c.largefont);
					p += c.largefont ? 10 : 8;
					t += strlen (t) + 1;
				}
			}
		}
		break;
	}
	//copyscreen();tdelay (200);
}

int mouseptr = 0;

void drawmouse ()
{
	byte mp [2] [16][16] = {
		// Regular mouseptr
		{{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x0A,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x0A,0x0C,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x0A,0x0C,0x0C,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x0A,0x0D,0x0E,0x0C,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x0A,0x0D,0x0E,0x0C,0x0A,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x0A,0x0C,0x0C,0x0A,0x10,0x10,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x08,0x10,0x08,0x0A,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x10,0x10,0x08,0x0A,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x10,0x00,0x00,0x10,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x10,0x0A,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x10,0x08,0x08,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x10,0x10,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
		// Wait mouseptr
		{{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 },
		{ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }}
	};
	byte hotx [2] = { 1, 0 };
	byte hoty [2] = { 1, 0 };
	int x, y;

	for (y = mousey; y < mousey + 16; y++) {
		if (y-hoty[mouseptr] < yres && y-hoty[mouseptr] >= 0) {
			for (x = mousex; x < mousex + 16; x++) {
				if ((x-hotx[mouseptr]) < xres && mp [mouseptr] [y-mousey] [x-mousex] != 0) {
					vs [((y-hoty[mouseptr]) * xres + (x-hotx[mouseptr]))] = mp [mouseptr] [y-mousey] [x-mousex];
				}
			}
		}
	}
}

#define LISTALLOCGRANULARITY 512

void enlargelistalloc (struct guicontrol &c, int col)
{
	struct listboxinfo *l = (struct listboxinfo *) c.text[4];
	char *oldmem = c.text[col];

	c.text[col] = (char *) malloc (l->col[col].totalmem += LISTALLOCGRANULARITY);
	memcpy (c.text[col], oldmem, l->col[col].usedmem);
	free (oldmem);
}

void setvisualinfo (struct guicontrol &c)
{
	struct listboxinfo *l = (struct listboxinfo *) c.text[4];

	l->lines = (c.h - 3) / (c.largefont ? 10 : 8);
	if (l->entries <= l->lines) {
		l->shaft = false;
		l->offset = 0;
		return;
	}
	if (l->offset + l->lines > l->entries)
		l->offset = l->entries - l->lines;
	if (l->offset < 0)
		l->offset = 0;
	l->shaft = true;
	l->shaftht = c.h - 24;
	l->sboxht = l->shaftht * l->lines / l->entries;
	l->sboxpos = (l->shaftht-l->sboxht) * l->offset / (l->entries-l->lines);
}

void initlistbox (struct guicontrol &c)
{
	int x;
	struct listboxinfo *l;

	uninitlistbox (c);
	c.text[4] = (char *) malloc (sizeof (struct listboxinfo));
	l = (struct listboxinfo *) c.text[4];
	l->entries = l->offset = l->lines = 0;
	l->shaft = false;
	l->upclicked = l->downclicked = false;
	l->offset = 0;
	for (x = 0; x < 4; x++) {
		c.text[x] = (char *) malloc (LISTALLOCGRANULARITY);
		l->col[x].xoffset = 2;
		l->col[x].totalmem = LISTALLOCGRANULARITY;
		l->col[x].usedmem = 0;
	}
	c.choice = 0;
	setvisualinfo (c);
}

void uninitlistbox (struct guicontrol &c)
{
	int x;
	
	for (x = 0; x < 5; x++) {
		if (c.text[x] != NULL)
			free (c.text[x]);
		c.text[x] = NULL;
	}
}

void addlistentry (struct guicontrol &c, int where)
{
	struct listboxinfo *l = (struct listboxinfo *) c.text[4];
	int col, epos;

	if (where > l->entries) return;
	for (col = 0; col < 4; col++) {
		if (l->col[col].usedmem == l->col[col].totalmem)
			enlargelistalloc (c, col);
		epos = findlistentry (c, where, col);
		memmove (c.text[col]+epos+1, c.text[col]+epos, l->col[col].usedmem - epos);
		l->col[col].usedmem++;
		c.text[col][epos] = '\0';
	}
	l->entries++;
	setvisualinfo (c);
}

void removelistentry (struct guicontrol &c, int where)
{
	struct listboxinfo *l = (struct listboxinfo *) c.text[4];
	int col, epos, size;

	if (where >= l->entries) return;
	for (col = 0; col < 4; col++) {
		epos = findlistentry (c, where, col);
		size = strlen (c.text[col]+epos) + 1;
		memmove (c.text[col]+epos, c.text[col]+epos+size, l->col[col].usedmem - epos - size);
		l->col[col].usedmem -= size;
	}
	l->entries--;
	setvisualinfo (c);
}

void changelistentry (struct guicontrol &c, int where, int col, char *s)
{
	struct listboxinfo *l = (struct listboxinfo *) c.text[4];
	int epos, oldsize, newsize;

	if (where >= l->entries) return;
	epos = findlistentry (c, where, col);
	oldsize = strlen (c.text[col]+epos) + 1;
	newsize = strlen (s) + 1;
	if (l->col[col].usedmem + (newsize - oldsize) >= l->col[col].totalmem)
		enlargelistalloc (c, col);
	memmove (c.text[col]+epos+newsize, c.text[col]+epos+oldsize, l->col[col].usedmem - epos - oldsize);
	strcpy (c.text[col]+epos, s);
	l->col[col].usedmem += (newsize - oldsize);
}

int findlistentry (struct guicontrol &c, int where, int col)
{
	int x;

	for (x = 0; where > 0; x++, where--) {
		while (c.text[col][x] != '\0') {
			x++;
		}
	}
	return x;
}

int findid (struct guiwindow &w, struct guicontrol &c)
{
	int y;

	for (y = 0; y < w.numcontrols; y++)
		if (&w.c[y] == &c)
			return y;
	return NULL;
}

void deftextmessage (struct guiwindow &w, struct guicontrol &c, int msg, int v1)
{
	(void) w; (void) c; (void) msg; (void) v1; // suppress warning
}

void defbuttonmessage (struct guiwindow &w, struct guicontrol &c, int msg, int v1)
{
	switch (msg) {
	case MOUSEPRESS:
		if (mouseison (w, c, c.focus)) {
			while (lbutton) {
				checkmouse ();
				c.clicked = mouseison (w, c, c.focus);
				showgui ();
			}
		}
		c.clicked = false;
		if (mouseison (w, c, c.focus)) {
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.focus);
		}
		break;
	case KEYPRESS:
		if (v1 == KEYSPACE || v1 == KEYENTER) {
			while (keydown [KEYSPACE] || keydown [KEYENTER]) {
				c.clicked = true;
				showgui ();
			}
			c.clicked = false;
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.focus);
		}
		break;
	case KEYCHAR:
		if (v1 == 128+'K') {
			c.focus--;
			if (c.focus < 0) c.focus = c.number-1;
		} else if (v1 == 128+'M') {
			c.focus++;
			if (c.focus >= c.number) c.focus = 0;
		}
		break;
	}
}

void defslidermessage (struct guiwindow &w, struct guicontrol &c, int msg, int v1)
{
	switch (msg) {
	case KEYCHAR:
		if (v1 == 128+'K') {
			c.choice -= c.interval;
			if (c.choice < c.min) c.choice = c.min;
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.focus);
		} else if (v1 == 128+'M') {
			c.choice += c.interval;
			if (c.choice > c.max) c.choice = c.max;
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.focus);
		}
		break;
	case MOUSEPRESS:
		if (lbutton) {
			while (lbutton) {
				checkmouse ();
				v1 = mousex - w.x - c.x[0];
				v1 = INLIMITS (v1, 0, (c.w-4));
				c.choice = v1 * (c.max-c.min) / (c.w-4) + c.min;
				sendmessage (&w, CONTROLCHANGE, findid (w, c), c.focus);
				showgui ();
			}
		}
		break;
	}
}

void defkeycodemessage (struct guiwindow &w, struct guicontrol &c, int msg, int v1)
{
	switch (msg) {
	case KEYPRESS:
		if (v1 == KEYESC) break;
		c.choice = v1;
		sendmessage (&w, CONTROLCHANGE, findid (w, c), c.choice);
		break;
	}
}

void defcheckorradiomessage (struct guiwindow &w, struct guicontrol &c, int msg, int v1)
{
	switch (msg) {
	case MOUSEPRESS:
		while (lbutton) {
			checkmouse ();
			c.clicked = mouseison (w, c, c.focus);
			showgui ();
		}
		c.clicked = false;
		if (mouseison (w, c, c.focus)) {
			if (c.type == RADIO) {
				c.choice = c.focus;
			} else {
				c.choice ^= (1 << c.focus);
			}
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.focus);
		}
		break;
	case KEYPRESS:
		if (v1 == KEYSPACE || v1 == KEYENTER) {
			while (keydown [KEYSPACE] || keydown [KEYENTER]) {
				c.clicked = true;
				showgui ();
			}
			c.clicked = false;
			if (c.type == RADIO) {
				c.choice = c.focus;
			} else {
				c.choice ^= (1 << c.focus);
			}
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.focus);
		}
	case KEYCHAR:
		if (v1 == 128+'K') {
			c.focus--;
			if (c.focus < 0) c.focus = c.number-1;
		} else if (v1 == 128+'M') {
			c.focus++;
			if (c.focus >= c.number) c.focus = 0;
		}
		if (c.type == RADIO) {
			c.choice = c.focus;
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.choice);
		}
	}
}

void definputmessage (struct guiwindow &w, struct guicontrol &c, int msg, int v1)
{
	int x, p, v2, tw, lw;
	
	switch (msg) {
	case KEYCHAR:
		switch (v1) {
		case 128+'K':
			if (c.choice > 0) c.choice--;
			break;
		case 128+'M':
			if (c.choice < strlen (c.text[0])) c.choice++;
			break;
		case 128+'G':
			c.choice = 0;
			break;
		case 128+'O':
			c.choice = strlen (c.text[0]);
			break;
		case 8:
			if (c.choice <= 0) break;
			c.choice--;
		case 128+83:
			for (v2 = c.choice; c.text[0][v2] != '\0'; v2++) {
				c.text[0][v2] = c.text[0][v2 + 1];
			}
			break;
		}
		if (v1 >= 32 && v1 <= 127 && strlen (c.text[0]) < c.max) {
			for (v2 = strlen (c.text[0]) + 1; v2 > c.choice; v2--) {
				c.text[0][v2] = c.text[0][v2 - 1];
			}
			c.text[0][c.choice] = v1;
			c.choice++;
		}
		break;
	case MOUSEPRESS:
		x = mousex - (w.x+c.x[0]+2);
		for (p = 0, tw = 0; tw < x; p++) {
			lw = (c.largefont ? width10[c.text[0][p]] : width8[c.text[0][p]]);
			tw += lw;
			if (c.text[0][p] == '\0') break;
		}
		if (tw - x > lw / 2 && p > 0)
			p--;
		c.choice = p;
		break;
	}
}

void deflistboxmessage (struct guiwindow &w, struct guicontrol &c, int msg, int v1)
{
	struct listboxinfo *l = (struct listboxinfo *) c.text[4];
	int y, repstart, cx = w.x+c.x[0], cy = w.y+c.y[0];
	
	switch (msg) {
	case MOUSEPRESS:
		if (l->shaft && mousex >= cx+c.w-12) {
			if (mousey < cy+12) { // Up arrow
				l->offset--;
				setvisualinfo (c);
				l->upclicked = true;
				repstart = tmsec + 300;
				showgui ();
				while (lbutton) {
					if (tmsec > repstart) {
						l->offset--;
						setvisualinfo (c);
						repstart += 75;
						showgui ();
					}
					checkmouse ();
				}
				l->upclicked = false;
			} else if (mousey > cy+c.h-13) { // Down arrow
				l->offset++;
				setvisualinfo(c);
				l->downclicked = true;
				repstart = tmsec + 300;
				showgui ();
				while (lbutton) {
					if (tmsec > repstart) {
						l->offset++;
						setvisualinfo (c);
						repstart += 75;
						showgui ();
					}
					checkmouse ();
				}
				l->downclicked = false;
			} else if (mousey >= cy+12+l->sboxpos && mousey < cy+12+l->sboxpos+l->sboxht) {
				y = mousey - l->sboxpos;
				while (lbutton) {
					l->sboxpos = mousey - y;
					if (l->sboxpos < 0)
						l->sboxpos = 0;
					if (l->sboxpos + l->sboxht >= l->shaftht)
						l->sboxpos = l->shaftht - l->sboxht - 1;
					l->offset = l->sboxpos * (l->entries-l->lines) / (l->shaftht-l->sboxht-1);
					/* l->sboxpos                    * l->offset *
					   -------------------------- = ---------------------
					   l->shaftht - l->sboxht - 1   l->entries - l->lines
					*/
					setvisualinfo (c);
					showgui ();
				}
			} else if (mousey >= cy+12+l->sboxpos+l->sboxht) {
				l->offset += l->lines-1;
				setvisualinfo (c);
			} else if (mousey < cy+12+l->sboxpos) {
				l->offset -= l->lines-1;
				setvisualinfo (c);
			}
			break;
		}
		if (mousey >= cy+1 && mousey < cy+2 + l->lines*(c.largefont ? 10 : 8)) {
			c.choice = l->offset + (mousey-cy-2) / (c.largefont ? 10 : 8);
			if (c.choice >= l->entries) c.choice = l->entries-1;
			if (c.choice < 0) c.choice = 0;
			if (doubleclick)
				sendmessage (&w, CONTROLCHANGE, findid (w, c), c.choice);
		}
		break;
	case KEYCHAR:
		if (v1 == 'K'+128) {
			c.choice--;
		} else if (v1 == 'M'+128) {
			c.choice++;
		} else if (v1 == 'I'+128) {
			c.choice -= l->lines;
		} else if (v1 == 'Q'+128) {
			c.choice += l->lines;
		} else if (v1 == 13) {
			sendmessage (&w, CONTROLCHANGE, findid (w, c), c.choice);
		}
		if (c.choice >= l->entries)
			c.choice = l->entries-1;
		if (c.choice < 0)
			c.choice = 0;
		if (c.choice < l->offset + 1)
			l->offset = c.choice - 1;
		if (c.choice >= l->offset + l->lines - 1)
			l->offset = c.choice - l->lines + 2;
		setvisualinfo (c);
		break;
	}
}

inline boolean setxclicked (struct guiwindow &w)
{
	return w.xclicked = (mousex >= w.x+w.w-12 && mousex <= w.x+w.w -4 && mousey >= w.y + 3 && mousey <= w.y + 11);
}

boolean mouseison (struct guiwindow &w, struct guicontrol &c, int subctl)
{
	int width, height;
	getcontrolsize (&c, subctl, width, height);
	return mousex >= w.x+c.x[subctl] && mousex < w.x+c.x[subctl]+width && mousey >= w.y+c.y[subctl] && mousey < w.y+c.y[subctl]+height;
}

void defwindowproc (struct guiwindow &w, int msg, int cnum, int v1)
{
	int x, y, temp;
	struct guicontrol *c = &w.c[w.focus];

	(void) cnum; // suppress warning
	switch (msg) {
	case OPENWINDOW:
		for (w.skip = 4; w.skip > 0; w.skip--) {
			showgui ();
		}
		break;
	case CLOSEWINDOW:
		if (win[0]->zorder == w.zorder) {
			storewinsettings ();
			for (x = 1; x < NUMWINDOWS; x++) {
				killwindow (x);
			}
		}
		y = (win[0]->zorder == w.zorder);
		for (w.skip = 1; w.skip < 4 + (y * 3); w.skip++) {
			if (y) {
				quitemu = true;
				tdelay (50);
				for (x = 0; x < 255; x++) {
					pal[x] = ((pal[x] >> 1) & 0x7F7F7F)+1;
				}
				waitforretrace();
				for (x = 0; x < 255; x++) {
					setpaletteentry (x, pal[x]-1);
				}
			}
			showgui ();
		}
		break;
	case KEYCHAR:
		if (w.tabonly && (v1 == 128+'H')) v1 = 128+'K';
		if (w.tabonly && (v1 == 128+'P')) v1 = 128+'M';
		if (v1 == 27) {
			if (activewindow () == 0) {
				if (!escquits)
					returntogame = true;
				else
					sendmessage (&w, CONTROLCHANGE, 8, 0);
			} else {
				killwindow (&w);
			}
			return;
		}
		if (v1 == 9 || v1 == 128+'P') {
			advancefocus (&w);
		} else if (v1 == 143 || v1 == 128+'H') {
			backupfocus (&w);
		}
		break;
	case MOUSEPRESS:
		if (setxclicked (w)) {
			while (lbutton) {
				checkmouse ();
				setxclicked (w);
				showgui ();
			}
		}
		if (w.xclicked) {
			w.xclicked = false;
			//if (activewindow () == 0 && !escquits)
			//	returntogame = true;
			//else 
				killwindow (&w);
			return;
		}
		if (lbutton && mousex >= w.x + 2 && mousex <= w.x + w.w - 3 && mousey >= w.y + 2 && mousey <= w.y + 12) {
			x = mousex - w.x;
			y = mousey - w.y;
			while (lbutton) {
				checkmouse ();
				w.x = mousex - x;
				w.y = mousey - y;
				showgui ();
			}
		}
		x = whichcontrol (&w, mousex, mousey, &y);
		//addmessage ("Which control? %d Text[0] %s", x, w.c[x].text[0]);
		if (x >= 0) {
			w.focus = x;
			w.c[x].focus = y;
		} else {
			return; // Shouldn't send click message to control that wasn't clicked
		}
		break;
	}
	if (!w.c[w.focus].disabled && !w.c[w.focus].hidden) {
		switch (w.c[w.focus].type) {
		case TEXT:
			deftextmessage (w, w.c[w.focus], msg, v1);
			break;
		case BUTTON:
			defbuttonmessage (w, w.c[w.focus], msg, v1);
			break;
		case SLIDER:
			defslidermessage (w, w.c[w.focus], msg, v1);
			break;
		case KEYCODE:
			defkeycodemessage (w, w.c[w.focus], msg, v1);
			break;
		case CHECK: case RADIO:
			defcheckorradiomessage (w, w.c[w.focus], msg, v1);
			break;
		case INPUT:
			definputmessage (w, w.c[w.focus], msg, v1);
			break;
		case LISTBOX:
			deflistboxmessage (w, w.c[w.focus], msg, v1);
			break;
		}
	}
}

void initgui ()
{
	int y;

	for (y = 0; y < NUMWINDOWS; y++) {
		win[y]->zorder = -1;
	}
	applywinsettings ();
	memset (ramcheatmarker, 0xFF, sizeof (ramcheatmarker));
	updatecheatsearchlisting (0);
}

void showwindow (struct guiwindow *w)
	// function can also bring a window to the top, if it's already visible.
{
	int y;

	if (w->zorder >= 0) {
		for (y = 0; y < NUMWINDOWS; y++) {
			if (win [y]->zorder >= 0 && win [y]->zorder < w->zorder)
				win [y]->zorder++;
		}
		w->zorder = 0;
		return;
	}
	for (y = 0; y < NUMWINDOWS; y++) {
		if (win [y]->zorder >= 0)
			win [y]->zorder++;
	}
	w->zorder = 0;
	sendmessage (w, OPENWINDOW);
}

void killwindow (struct guiwindow *w)
{
	int y;
	
	if (w->zorder < 0) return;
	sendmessage (w, CLOSEWINDOW);
	for (y = 0; y < NUMWINDOWS; y++) {
		if (win [y]->zorder > w->zorder)
			win [y]->zorder--;
	}
	w->zorder = -1;
}

int activewindow ()
{
	int y, smz = 127, act = 0;
	for (y = 0; y < NUMWINDOWS; y++) {
		if (win[y]->zorder >= 0 && win[y]->zorder < smz) {
			smz = win[y]->zorder;
			act = y;
		}
	}
	return act;
}

void advancebadfocus (struct guiwindow *w)
{
	int start;
	
	if (w->focus >= w->numcontrols) {
		w->focus = 0;
	}
	start = w->focus;
	while (w->c[w->focus].type == TEXT || w->c[w->focus].disabled || w->c[w->focus].hidden) {
		//debugf(0,"focus %d type %d num %d visible %d disabled %d", w->focus, w->c[w->focus].type, w->numcontrols, w->c[w->focus].hidden, w->c[w->focus].disabled);
		w->focus++;
		if (w->focus >= w->numcontrols)
			w->focus = 0;
		if (w->focus == start) {
			return;
		}
	}
	if (w->c[w->focus].type == RADIO)
		w->c[w->focus].focus = w->c[w->focus].choice;
}

void advancefocus (struct guiwindow *w)
{
	w->focus++;
	advancebadfocus (w);
}

void backupfocus (struct guiwindow *w)
{
	do {
		w->focus--;
		if (w->focus < 0)
			w->focus = w->numcontrols - 1;
	} while (w->c[w->focus].type == TEXT || w->c[w->focus].disabled || w->c[w->focus].hidden);
	if (w->c[w->focus].type == RADIO)
		w->c[w->focus].focus = w->c[w->focus].choice;
}

void getcontrolsize (struct guicontrol *c, int subctl, int &w, int &h)
{
	w = c->w;
	if (w == 0) {
		if (c->largefont == false)
			w = textwidth8 (c->text[subctl]);
		else
			w = textwidth10 (c->text[subctl]);
		if (c->type != TEXT) w += 8;
	}
	h = c->h;
	if (h == 0) {
		if (c->largefont == false) h = 8;
		else h = 10;
	}
}

/*int whichwindow (int x, int y)
{
	int z, w;

	for (z = 0; z < 128; z++)
		for (w = 0; w < NUMWINDOWS; w++) 
			if (win[w]->zorder == z && win[w]->x <= x && win[w]->x + win[w]->w > x && win[w]->y <= y && win[w]->y + win[w]->h > y)
				return w;
	return -1;
}*/

int whichcontrol (int wnum, int x, int y, int *subctl)
{
	return whichcontrol (win[wnum], x, y, subctl);
}

int whichcontrol (struct guiwindow *window, int x, int y, int *subctl)
{
	int c, s, w, h, num;
	struct guicontrol *wc;
	
	x -= window->x;
	y -= window->y;
	for (c = 0; c < window->numcontrols; c++) {
		wc = &window->c[c];
		if (wc->disabled || wc->hidden)
			continue;
		if (wc->number <= 0) wc->number = 1;
		num = wc->number;
		if (wc->type == LISTBOX) num = 1;
		for (s = 0; s < num; s++) {
			getcontrolsize (wc, s, w, h);
			if (x >= wc->x[s] && x < wc->x[s] + w && y >= wc->y[s] && y < wc->y[s] + h) {
				if (subctl != NULL)
					*subctl = s;
				return c;
			}
		}
	}
	return -1;
}

void setguisettings ()
{
	int x;
	
	for (x = 0; x < NUMWINDOWS; x++) {
		if (win[x]->zorder >= 0) {
			advancebadfocus (win[x]);
			if (win[x]->zorder >= 0)
				sendmessage (x, NEWGUIFRAME);
		}
	}
}

int guiframes = 0, guistarttime = 0, guifps = 0;

#define MAXMESSAGES 3
#define MESSAGETIME 3000

char messages [MAXMESSAGES] [100] = { "", "", "" };
long mstarttime [MAXMESSAGES] = { 0, 0, 0 };

void addmessage (char *format, ...)
{
	va_list arglist;
	int m;
	char message [100];

	va_start (arglist, format);
	vsprintf (message, format, arglist);
	debug0 ("Message added: %s", message);
	/*for (m = 0; m < MAXMESSAGES; m++) {
		if (strcmp (message, messages[m]) == 0) {
			//debug0 ("  [already in queue]");
			return; // Message already in queue
		}
	}*/
	for (m = 0; m < MAXMESSAGES - 1; m++) {
		strcpy (messages [m], messages [m + 1]);
		mstarttime [m] = mstarttime [m + 1];
	}
	strcpy (messages [m], message);
	mstarttime [m] = tmsec;
	//debug0 ("Finished adding message");
	va_end (arglist);
}

int messagecolor = 0;
boolean messageoutline = true;

void showmessages ()
{
	int m, extraup = (yres == 256 ? 10 : 0);
	
	for (m = 0; m < MAXMESSAGES; m++) {
		if (mstarttime[m] + MESSAGETIME >= tmsec) {
			if (messageoutline) {
				setcolor (0);
				outtext8 (4, (yres-MAXMESSAGES*10-2-extraup) + m * 10, messages [m]);
				outtext8 (2, (yres-MAXMESSAGES*10-3-extraup) + m * 10, messages [m]);
				outtext8 (4, (yres-MAXMESSAGES*10-3-extraup) + m * 10, messages [m]);
				outtext8 (3, (yres-MAXMESSAGES*10-2-extraup) + m * 10, messages [m]);
				outtext8 (3, (yres-MAXMESSAGES*10-4-extraup) + m * 10, messages [m]);
			}
			setcolor (messagecolor);
			outtext8 (3, (yres-MAXMESSAGES*10-3-extraup) + m * 10, messages [m]);
		}
	}
}

byte gamepalmap [256];

void showgui ()
{
	int x, y, ux, uy;
	dword gp;
	int topmost = activewindow ();
	static set=0;
	
	switch (background) {
	case 0: // Black
		x = rand() % 10;
		if (x == 0 && set > 0) set--;
		if (x == 1 && set < 15) set++;
		clearscreen (CCOLOR (set,0));
		break;
	case 1: // Rainbow
		ux = xres / 16;
		uy = yres / 16;
		for (y = 0; y < 16; y++) {
			for (x = 0; x < 16; x++) {
				drawpatternbox (xres*x/16-ux/2, yres*y/16, xres*x/16, yres*(y+1)/16, x*16+y, 1);
				//drawpatternbox (xres*x/16, yres*y/16-uy/2, xres*(x+1)/16-ux/2-1, yres*y/16, x*16+y, 1);
				drawbox        (xres*x/16, yres*y/16, xres*(x+1)/16, yres*(y+1)/16, x*16+y);
			}
		}
		break;
	case 2: // Game
		clearscreen ();
		ux = (xres - 256) / 2;
		uy = (yres - 256) / 2;
		for (y = uy; y < uy+240; y++) {
			if (y < 0 || y >= yres)
				continue;
			for (x = ux; x < ux+256; x++) {
				vs [y * xres + x] = gamepalmap [snesscreen [((y-uy) << 8) + (x-ux)]];
			}
		}
		break;
	case 3:
		clearscreen ();
		ux = (xres - 256) / 2;
		uy = (yres - 240) / 2;
		for (y = uy; y < uy+240; y++) {
			for (x = ux; x < ux+256; x++) {
				gp = gamepalmap [snesscreen [((y-uy) << 8) + (x-ux)]];
				vs [y * xres + x] = (gp & 0xF0) | ((gp & 0x0F) >> 1);
			}
		}
		break;
	}
	for (x = 127; x >= 0; x--) {
		for (y = 0; y < NUMWINDOWS; y++) {
			if (win[y]->zorder == x)
				drawwindow (*win[y], y == topmost);
		}
	}
	checkmouse ();
	showmessages ();
	drawmouse ();
	copyscreen ();
	guiframes++;
}

boolean returntogame = false;
boolean quitemu = false;
boolean doubleclick = false;

int rungui (void)
{
	int x, y;
	boolean prevkey [128];
	int topmost, newtop, prevlb, prevrb;
	int lastlclick = 0, lastlclickx, lastlclicky;

	setvideomode (guires, false);
	applycustompalette ();
	for (y = 0; y < 256; y++) {
		gamepalmap[y] = rgbtocpalette (gamepalette [y]);
	}
	guistarttime = tmsec;
	guiframes = 0;
	returntogame = false;
	quitemu = false;
	showwindow (0);
	messagecolor = 15;
	messageoutline = true;
	do {
		for (y = 0; y < NUMWINDOWS; y++) {
			if (win[y]->y > yres - 3)
				win[y]->y = yres - 3;
			if (win[y]->x > xres - 3)
				win[y]->x = xres - 3;
		}
		for (x = 0; x < 128; x++)
			prevkey [x] = keydown [x];
		if (joypadwindow.zorder >= 0 && (jpc[2].choice == 2 || jpc[2].choice == 4 || jpc[2].choice == 5)) 
			checkjoystick (); // Joypad or extra selected for control
		prevlb = lbutton;
		prevrb = rbutton;
		setguisettings ();
		showgui ();
		topmost = activewindow ();
		if ((lbutton && !prevlb) || (rbutton && !prevrb)) {
			newtop = -1;
			for (x = 0; x < 128 && newtop < 0; x++) {
				for (y = 0; y < NUMWINDOWS; y++) {
					if (win[y]->zorder == x &&
						mousex >= win[y]->x && mousex < win[y]->x + win[y]->w &&
						mousey >= win[y]->y && mousey < win[y]->y + win[y]->h) {
						newtop = y;
						break;
					}
				}
			}
			if (newtop >= 0 && win[newtop]->zorder > 0)
				showwindow (topmost = newtop);
			if (lbutton && !prevlb) {
				if (tmsec - lastlclick < 500 && mousex > lastlclickx - 3 && mousex < lastlclickx + 3 &&
					mousey > lastlclicky - 3 && mousey < lastlclicky + 3) {
					doubleclick = true;
					sendmessage (topmost, MOUSEPRESS, -1, 0);
					doubleclick = false;
				} else {
					lastlclick = tmsec;
					lastlclickx = mousex;
					lastlclicky = mousey;
					sendmessage (topmost, MOUSEPRESS, -1, 0);
				}
			} else {
				sendmessage (topmost, MOUSEPRESS, -1, 1);
			}
		}
		if (!lbutton && prevlb) {
			sendmessage (topmost, MOUSERELEASE, -1, 0);
		}
		if (!rbutton && prevrb) {
			sendmessage (topmost, MOUSERELEASE, -1, 1);
		}
		if (kbhit ()) {
			x = getch ();
			if (x == 0)
				x = getch () + 128;			
			if (x == 192) { // F6
				for (x = 127; x > 0; x--)
					for (y = 0; y < NUMWINDOWS; y++)
						if (win[y]->zorder == x) {
							showwindow (y);
							x = 0; // break outer
						}
			}
			if (x == 217) { // Shift+F6
				for (x = 1; x < 127; x++)
					for (y = 0; y < NUMWINDOWS; y++)
						if (win[y]->zorder == x) {
							showwindow (y);
							x = 127; // break outer
						}
			}
			debug0 ("sending keychar msg");
			sendmessage (topmost, KEYCHAR, win[topmost]->focus, x);
		}
		for (x = 0; x < 128; x++) {
			if (keydown [x] && !prevkey [x]) {
				debug0 ("sending keypress msg");
				sendmessage (topmost, KEYPRESS, win[topmost]->c[win[topmost]->focus].focus, x);
			}
			if (!keydown [x] && prevkey [x]) {
				debug0 ("sending keyrelease msg");
				sendmessage (topmost, KEYRELEASE, win[topmost]->c[win[topmost]->focus].focus, x);
			}
		}
		if (tmsec-guistarttime > 0) {
			guifps = guiframes * 1000 / (tmsec - guistarttime);
		}
		if (tmsec - guistarttime > 4000) {
			guiframes = guiframes * 2000 / (tmsec - guistarttime);
			guistarttime = tmsec - 2000;
		}
		win[0]->c[NUMMAINCONTROLS-1].text[1][19] = (guifps / 100) + '0';
		win[0]->c[NUMMAINCONTROLS-1].text[1][20] = (guifps / 10) % 10 + '0';
		win[0]->c[NUMMAINCONTROLS-1].text[1][21] = (guifps % 10) + '0';
	} while (!(returntogame && romloaded) && !quitemu);
	if (quitemu) return GUIQUIT;
	return GUIRETURN;
}
